/*
 * Copyright (C) 2020 Tycho Softworks.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SERVER_HPP_
#define SERVER_HPP_

#ifdef __clang__
#pragma clang diagnostic ignored "-Wpadded"
#pragma clang diagnostic ignored "-Wswitch-enum"
#pragma clang diagnostic ignored "-Wweak-vtables"
#pragma clang diagnostic ignored "-Wunused-member-function"
#endif

#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-result"
#pragma GCC diagnostic ignored "-Wzero-as-null-pointer-constant"
#endif

#if __cplusplus < 201703L
#error C++17 compliant compiler required
#endif

#include <moderncli/templates.hpp>
#include <moderncli/print.hpp>

#include <atomic>
#include <cassert>

using namespace tycho;
using error = std::runtime_error;
using range = std::out_of_range;

namespace server {
inline std::atomic<bool> running{false};
inline std::atomic<bool> exiting{false};
inline system_logger logger;
inline bool ipv6{false};
} // end namespace

// Linting defines
#ifndef PROJECT_VERSION
#define PROJECT_VERSION "unknown"                       // NOLINT
#define PROJECT_SOURCE_DIR "."                          // NOLINT
#define SERVER_ID "coventry"                            // NOLINT
#define SERVER_IPCPATH "/coventry-system"               // NOLINT
#define SERVER_CONTROL_IPC "/coventry-system"           // NOLINT
#define SERVER_CONFIG_FILE "/etc/coventry.conf"         // NOLINT
#define SERVER_LOGGER_PATH "/var/log"                   // NOLINT
#define SERVER_PREFIX_PATH "/var/lib/coventry"          // NOLINT
#define TUNE_CALL_LIMIT 100                             // NOLINT
#define HAVE_MQUEUE 1                                   // NOLINT
#endif
#endif
